import java.io.*;

import java.net.*;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Vector;
//̿ϼԴϴ.
	//@@@@@@@@@@@@@@@@@@
	//@  1:1 TCP/IP Socket Class     @
	//@@@@@@@@@@@@@@@@@@

public class GameNetworkModule 
{
	private Vector fTextListeners    = new Vector();
	private TcpIpServer fServer;
	private TcpIpClient fClient;
	private TetrisGame fGame;
	private int     	      fPort;
	private boolean	  fHost;
	private boolean     fPlaying;
	
	public GameNetworkModule(TetrisGame tetrisGame,boolean host){
			//
			fPlaying = false;
			fGame = tetrisGame;
			fHost   = host;
			fPort    = 9112;
			startNetwork();						
	}
	
	public void startNetwork()
	{
		
		if(fHost) fServer = new TcpIpServer(fPort);
		else fClient = new TcpIpClient("116.126.155.131",fPort);
	}
	
	public void clientGameStart()
	{
		fPlaying = true;
			
	}
	
	public void stopServer()// 
	{
		fServer.stopServer();
	}
	
	public static String getTime()// ð
	{
		SimpleDateFormat f = new SimpleDateFormat(" [hh:mm:ss] ");
		return f.format(new Date());
	}
	
	//@@@@@@@@@@@@@@@@@@@@@
	//@                 
	public class TcpIpServer extends Thread {
		
		private ServerSocket serverSocket = null;
		private Socket socket = null;
		private Thread sender = null;
		private Thread receiver = null;
		private int port;
				
		public TcpIpServer(int port) {
					
			try
			{				
				serverSocket = new ServerSocket(port);
				System.out.println("  Ǿϴ..");	
				fGame.useEventHandler(" Ǿϴ.");
			}			
			catch(IOException e)
			{
				System.out.println("   .");
				e.printStackTrace();
			}
			start();
		}
		
		public void run(){
			while(true)
			{
				try
				{					
					fGame.useEventHandler("  ٸϴ");
				
					socket = serverSocket.accept();
					
					fGame.useEventHandler(serverSocket.getInetAddress() 
							+ "û Խϴ.");
					
					Sender fSender    = new Sender(socket);
					Receiver fReceiver  = new Receiver(socket);
					sender   = new Thread(fSender);
					receiver = new Thread(fReceiver);
					
					fGame.setNetworkOnOff();
					startServer();
				}
				catch(SocketTimeoutException e){e.printStackTrace();}
				catch(IOException e){	e.printStackTrace();}
			}
		}
		public void stopServer()
		{
			try
			{
			serverSocket.close();
			fGame.useEventHandler("Host մϴ.");	
			}
			catch(IOException e){	e.printStackTrace();}
		}
		
		private void startServer()
		{		
			
			sender.start();
			receiver.start();
		}
		
	}//TcpIpServer
	
	//@@@@@@@@@@@@@@@@@@@@@
	//@                 Ŭ̾Ʈ
	public class TcpIpClient {
		
		private Socket socket = null;
		private Thread sender = null;
		private Thread receiver = null;
		
		
		public TcpIpClient(String serverIp,int port){
				
			try
				{
				    fGame.useEventHandler(serverIp+" մϴ.");
					
					socket = new Socket(serverIp,port);
					fGame.useEventHandler("Host Ͽϴ.");
										
					Sender fSender    = new Sender(socket);
					Receiver fReceiver  = new Receiver(socket);
					sender   = new Thread(fSender);
					receiver = new Thread(fReceiver);
					
					sender.start();
					receiver.start();
					
				}
				catch(ConnectException ce)
				{
					ce.printStackTrace();
				}
				catch(IOException ie)
				{
					ie.printStackTrace();
				}
				catch(Exception e)
				{
					e.printStackTrace();
				}
		}

	}
	
	//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
	//@
	//@                        ۽  κ
	public class Sender implements Runnable{
		
		private Socket socket;
		private DataOutputStream out;
		
		
		public Sender(Socket socket)
		{
			
			this.socket=socket;
			
				try
				{
				out = new DataOutputStream(socket.getOutputStream());
				}
				catch(Exception e){e.printStackTrace();}
		}
		
		public void run()
		{
			
			while(out!=null){
					try
					{	
						
						//out.writeUTF("Դϴ.^^;");
						//try { Thread.sleep(1000); } catch (InterruptedException e) { System.err.println("Exception e: " + e); }
						out.writeBoolean(fPlaying);						
						//System.out.println("Ŭ̾Ʈ ޼ۿ Ͽϴ.");
						
					}
					catch(IOException e){	e.printStackTrace();}
			}
		}//run
	}//class
	
	//@@@@@@@@@@@@@@@@@@@@@@@@
	//@
	//@                        
	public class Receiver implements Runnable{
		private Socket socket;
		private DataInputStream in;
		private boolean fPlaying;
		private boolean lock;
		
		Receiver(Socket socket)
		{
			this.socket = socket;
			fPlaying = false;
			lock = true;
			try
			{
				in = new DataInputStream(socket.getInputStream());
			}
			catch(IOException e){ }
		}
		
		public void run()
		{	
			while(in!=null){
				try
				{
					if(!fPlaying) fPlaying = in.readBoolean();
					//fGame.useEventHandler(in2.readUTF());
					if(fPlaying && lock)
						{
						fGame.setNetworkOnOff();
						fGame.startGame();
						 lock = false;
						}
				
				}
				catch(IOException e)	{e.printStackTrace();}
			}
		}//run
	}//class
	 public void addTextListener(TextListener listener)
     {	
     	fTextListeners.addElement(listener);
     }
   
    public void removefTextListeners(TextListener listener)
    {
    	fTextListeners.removeElement(listener);
        
    }
    
    private void fireTextEvent(String msg){
		    	
    	BoardEvent event=new BoardEvent(msg);
		
		for (int count = 0; count < fTextListeners.size(); count++)
            ((TextListener)fTextListeners.elementAt(count)).TextChange(event);
			
    }



    public static GameNetworkModule getGameNetworkModule(TetrisGame tetrisGame,boolean host)
    {
    	return new GameNetworkModule(tetrisGame,host);
    }
}
