

import java.awt.Point;



public class TetrisPiece {
	//ǽ 翡  ȣ Ͽϴ.
	public static final int L_PIECE   = 0;
    public static final int J_PIECE   = 1;
    public static final int I_PIECE   = 2;
    public static final int Z_PIECE   = 3;
    public static final int S_PIECE   = 4;
    public static final int O_PIECE   = 5;
    public static final int T_PIECE   = 6;
	//Ű Է° ϱ    ȣ ԷϿϴ.
    public static final int LEFT      = 10;
    public static final int RIGHT     = 11;
    public static final int ROTATE    = 12;
    public static final int DOWN      = 13;
    public static final int FALL      = 14;
    
    private int fType;//ǽ 
    private int fMaxRotate;//ȸ
    int fRotation;
    
    private Point fCenterPoint = new Point();//ǽ ġ ǥ
	private Point[] fBlocks = new Point[4];//ǽ    
		
	private TetrisBoard fBoard;
	
	//	  ° ǽ 
	TetrisPiece(int fType,TetrisBoard board){
		this.fType=fType;
		this.fBoard=board;
		initializeBlocks();
	}
	// ǽ ִ 迭 ǥ մϴ.
	public Point getCentrePoint(){
        return fCenterPoint;
    }
	// ǽ ִ ġ  մϴ.//̻
    public void setCentrePoint(Point point){
    	fCenterPoint = point;
    }
    //̻ ǽ ִ 迭 մϴ.
    public Point[] getRelativePoints(){
        return fBlocks;
    }
    //ǽ  մϴ.
    public void setfType(int fType){
		this.fType=fType;
	}
    //ǽ    ޾ƿɴϴ. 
	public int getfType(){
		return fType;
	}
	//̻  ;	
    public void setRelativePoints(Point[] blocks){
        if (blocks != null) fBlocks = blocks;
    }
    //Ű Է° ޾  ̵ϴ ޼ҵ Դϴ.
    // ̵Ҽ  true ƴϸ false ȯմϴ.
	public boolean Move(int direction){
		boolean result= true;
			
		if(direction==FALL){
			boolean loop=true;
			
				
			while(loop){
						fBoard.RemovePiece(this);
						fCenterPoint.y++;
					if(fBoard.willFit(this))
					{
						fBoard.AddPiece(this,false);
					}	
					else
					{
						fCenterPoint.y--;
						fBoard.AddPiece(this,true);
						loop=false;
						result=false;
					}
				}
		}
		else{
			
			fBoard.RemovePiece(this);
				
			switch(direction){
					case LEFT : fCenterPoint.x--; break;
					case RIGHT : fCenterPoint.x++; break;
					case DOWN : fCenterPoint.y++; break;
					case ROTATE : rotateClockwise(); break;
			}
			
			if(fBoard.willFit(this)){
				fBoard.AddPiece(this,true);
			}
			
			else{
				switch(direction){
					case LEFT : fCenterPoint.x++; break;
					case RIGHT : fCenterPoint.x--; break;
					case DOWN : fCenterPoint.y--; break;
					case ROTATE : rotateAntiClockwise(); break;
				}
				fBoard.AddPiece(this,true);
				result=false;
			}
		}	
		return result;
	}
	//fType ߾ ǽ  մϴ.
	private void initializeBlocks()
    {
        switch (fType) 
    	{
            case I_PIECE : fBlocks[0] = new Point(0, 0);
                           fBlocks[1] = new Point(-1, 0);
                           fBlocks[2] = new Point(1, 0);
                           fBlocks[3] = new Point(2, 0);
                           fMaxRotate = 2;
                           break;
    	    
    	    case L_PIECE : fBlocks[0] = new Point(0, 0);
                           fBlocks[1] = new Point(-1, 0);
                           fBlocks[2] = new Point(-1, 1);
                           fBlocks[3] = new Point(1, 0);
             		       fMaxRotate = 4;
             		       break;
        
    	    case J_PIECE : fBlocks[0] = new Point(0, 0);
                           fBlocks[1] = new Point(-1, 0);
                           fBlocks[2] = new Point(1, 0);
                           fBlocks[3] = new Point(1, 1);
            		       fMaxRotate = 4;
               		       break;
        
    	    case Z_PIECE : fBlocks[0] = new Point(0, 0);
                           fBlocks[1] = new Point(-1, 0);
                           fBlocks[2] = new Point(0, 1);
                           fBlocks[3] = new Point(1, 1);
            		       fMaxRotate = 2;
            		       break;
    	    
    	    case S_PIECE : fBlocks[0] = new Point(0, 0);
                           fBlocks[1] = new Point(1, 0);
                           fBlocks[2] = new Point(0, 1);
                           fBlocks[3] = new Point(-1, 1);
            		       fMaxRotate = 2;
            		       break;
    
    	    case O_PIECE : fBlocks[0] = new Point(0, 0);
                           fBlocks[1] = new Point(0, 1);
                           fBlocks[2] = new Point(-1, 0);
                           fBlocks[3] = new Point(-1, 1);
            		       fMaxRotate = 1;
            		       break;
    	    
    	    case T_PIECE : fBlocks[0] = new Point(0, 0);
                           fBlocks[1] = new Point(-1, 0);
                           fBlocks[2] = new Point(1, 0);
                           fBlocks[3] = new Point(0, 1);
        		           fMaxRotate = 4;
        		           break;
    	}
    }
	//̿ϼ κ
	//ǽ ȸ մϴ. )׸   ȸ ʿ䰡 ϴ.
	public void rotateClockwise(){
		if(fMaxRotate>1){
			rotateClockwiseNow();
		}
	}
	/* ȸ
	*/
	void rotateClockwiseNow(){
		
			for(int i=0;i<fBlocks.length;i++){
				final int temp=fBlocks[i].x;
				fBlocks[i].x=-fBlocks[i].y;
				fBlocks[i].y=temp;
			}	
	}
	/* ȸ
	*/
	void rotateAntiClockwise(){
		rotateClockwiseNow();
		rotateClockwiseNow();
		rotateClockwiseNow();
	}
	//ڸ ̿ؼ ǽ մϴ. Math.random()޼ҵ带 Ͽ 
	//ǽ  ˴ϴ.
	 public static TetrisPiece getRandomPiece(TetrisBoard board)
	    {
	        return new TetrisPiece((int)(Math.random() * 7),board);
	    }
		
	}


